<template>
  <div>
    <section class="">
      <p class="font-weight-bold">Filter Sidebar component</p>
      <v-row align="center">

        <!--            Network Select Component-->
        <v-col class="" cols="4" sm="4">
          <span class="overline">Network</span>
          <v-select
            :items="networks"
            v-model="currentNetwork"
            @change="changeTable()"
            label="Select network"
            filled
          ></v-select>
        </v-col>

        <!--            Types Select Component-->
        <v-col class="" cols="4" sm="4">
          <span class="overline">Types</span>
          <v-select
            :items="types"
            v-model="currentType"
            @change="changeTable()"
            label="Select type"
            filled
          ></v-select>
        </v-col>

        <!--            Message Select Component-->
        <v-col class="" cols="4" sm="4">
          <span class="overline">Message</span>
          <v-text-field
            type="text"
            v-model="search"
            @keyup="changeTable()"
            label="Write something..."
            filled
          ></v-text-field>
        </v-col>
      </v-row>
      <PostsTable :posts="postsFiltered" :key="refresh"></PostsTable>

      <!--      Generate PDF -->
      <div class="mb-16">
        <v-btn @click="downloadPDF" color="error">Download PDF Report</v-btn>
        <VueHtml2pdf
          :manual-pagination="true"
          :enable-download="true"
          ref="DownloadComp"
          :show-layout="false"
          :float-layout="true"
          :preview-modal="true"
          :paginate-elements-by-height="1400"
          filename="Report PDF by Ilya"
          :pdf-quality="2"
          pdf-format="a4"
          :pdf-margin="10"
          pdf-orientation="portrait"
          pdf-content-width="800px"
          @progress="onProgress($event)"
        >
          <section slot="pdf-content">
            <PostsTable :posts="postsFiltered" :key="refresh"></PostsTable>
          </section>
        </VueHtml2pdf>
      </div>
      <div>

      </div>
    </section>
  </div>
</template>

<script>
import PostsTable from '@/components/PostsTable.component.vue'
import VueHtml2pdf from 'vue-html2pdf'
// import ContentToPrint from './ContentToPrint'

export default {
  name: 'FilterSidebar',
  components: {
    PostsTable,
    VueHtml2pdf,
    // ContentToPrint,
  },
  props: {
    posts: [Array, Object]
  },
  data () {
    return {
      refresh: 0,
      networks: [],
      currentNetwork: null,
      types: [],
      currentType: null,
      search: '',
      postsFiltered: [],
    }
  },
  methods: {
    changeTable () {

      // Network filter
      let arr = []
      if (!this.currentNetwork || this.currentNetwork === 'all') {
        arr = this.posts
      } else {
        this.posts.forEach(v => {
          if (v.network === this.currentNetwork) arr.push(v)
        })
      }

      // Types filter
      let arr2 = []
      if (!this.currentType || this.currentType === 'all') {
        arr2 = arr
      } else {
        arr.forEach(v => {
          if (v.type === this.currentType) arr2.push(v)
        })
      }

      // Search by text
      this.postsFiltered = []
      arr2.forEach(v => {
        if (v.copy.toLowerCase().includes(this.search.toLowerCase())) {
          this.postsFiltered.push(v)
        }
      })
      this.refresh++
    },

    // Generate PDF
    onProgress (event) {
      console.log(`Processed: ${event} / 100`)
    },
    downloadPDF () {
      this.$refs.DownloadComp.generatePdf()
    }
  },
  created () {
    this.postsFiltered = this.posts

    // Prepare networks array
    this.networks = []
    this.networks.push({
      value: 'all',
      text: 'all networks',
    })
    this.posts.reduce((r, o) => {
      if (!r[o.network]) {
        r[o.network] = o.network
        this.networks.push({
          value: o.network,
          text: o.network,
        })
      }
      return r
    }, {})

    // Prepare types array
    this.types = []
    this.types.push({
      value: 'all',
      text: 'all types'
    })
    this.posts.reduce((r, o) => {
      if (!r[o.type]) {
        r[o.type] = o.type
        this.types.push({
          value: o.type,
          text: o.type
        })
      }
      return r
    }, {})
  },
}
</script>
